<template>
    <v-row class="login-component" v-if="!$store.state.user.uuid">
        <v-col style="overflow: hidden;" cols="auto">
            <v-dialog class="dialog" fullscreen transition="dialog-top-transition">
                <template v-slot:activator="{ on, attrs }">
                    <v-btn @click="() => { dialogOpened = true; }" color="grey" icon v-bind="attrs" v-on="on">zaloguj się
                    </v-btn>
                </template>
                <template v-slot:default="dialog">
                    <v-card :class="{ glass: true, 'fade-out': !dialogOpened }"
                        style="background: rgba(255, 255, 255, 0.7) !important; width: 100vw; height: 100vh;">
                        <v-card-text>
                            <div class="text-h2 pa-12">
                                <v-form v-model="valid">
                                    <v-container style="overflow: hidden;">
                                        <v-row>
                                            <v-col class="column-form" cols="6">
                                                <span
                                                    style="display: flex; justify-content: center; box-shadow: none; margin: 58px;">
                                                    <span style="font: 12px;">Logowanie</span>
                                                </span>
                                                <v-row>
                                                    <v-col cols="12" md="12">
                                                        <v-text-field v-model="login" label="email bądź nick"
                                                            required></v-text-field>
                                                    </v-col>
                                                </v-row>
                                                <v-row>
                                                    <v-col cols="12" md="12">
                                                        <v-text-field v-model="password"
                                                            :append-icon="show ? 'mdi-eye' : 'mdi-eye-off'"
                                                            :type="show ? 'text' : 'password'" label="ustaw hasło" counter
                                                            @click:append="show = !show"></v-text-field>
                                                    </v-col>
                                                </v-row>
                                            </v-col>
                                            <v-col style="overflow: hidden;" class="image-column" cols="6">
                                                <v-container class="image-wrapper">
                                                    <v-img height="100vh" contain src="/login.jpg"></v-img>
                                                </v-container>
                                            </v-col>
                                        </v-row>
                                    </v-container>
                                </v-form>
                            </div>
                        </v-card-text>
                        <v-snackbar v-model="snackbar" :multi-line="multiLine" style="transform: translateY(-10vh);">
                            {{ message }}
                            <template v-slot:action="{ attrs }">
                                <v-btn color="warning" text v-bind="attrs" @click="snackbar = false">
                                    Zamknij
                                </v-btn>
                            </template>
                        </v-snackbar>
                        <v-card-actions class="justify-begin"
                            style="margin-left: 19vw; transform: translate(-30px,-128px);">
                            <v-btn class="margin" color="primary" text @click="handleLogin" fab icon plain raised
                                tile>Loguj</v-btn>
                            <v-btn class="margin" color="primary" text
                                @click="{ dialogOpened = false; dialog.value = false }" fab icon plain raised
                                tile>Zamknij</v-btn>
                        </v-card-actions>
                    </v-card>
                </template>
            </v-dialog>
        </v-col>
    </v-row>
</template>

<script>
export default {
    data() {
        return {
            valid: false,
            show: false,
            login: '',
            password: '',
            dialogOpened: false,
            multiLine: true,
            snackbar: false,
            message: ''
        }
    },

    methods: {

        handleLogin() {
            this.$emit('spinner', true);
            setTimeout(() => {
                if (this.snackbar) { return; }
                this.$emit('spinner', true);
                this.message = 'Problemy z serwerem. Nie poddawaj się i spróbuj powownie za jakiś czas.';
                this.snackbar = true;

            }, 5000),
                this.$axios.post(this.$config.serverUrl + '/user/login',
                    { login: this.login, password: this.password }).then(({ data }) => {
                        if (data.status === 'OK') {
                            this.$emit('spinner', false);
                            if (data.user.state === 'non-configured') {
                                this.$bus.$emit('hide-menu')
                            }
                            this.$store.dispatch('setUuid', data.uuid);
                            this.$store.dispatch('setUser', data.user);
                            this.$store.dispatch('setSocket', this.$config.webSocketUrl);
                            this.$store.dispatch('setBus', this.$bus);
                            this.message = 'Logowanie pomyślne';
                            this.snackbar = true;
                            setTimeout(() => {
                                this.dialogOpened = false;
                                this.$router.push({ path: '/profile' });
                            }, 2000);

                            this.$axios.post(this.$config.serverUrl + '/message/unread', {
                                uuid: this.$store.state.user.uuid
                            }).then(({ data }) => {
                                const messages = data.map(el=> { return {...el, number: +el.number}});
                                this.$store.dispatch('setUnreadMeassages', messages);
                                this.$bus.$emit('unreceivedMesages')
                            })
                        } else {
                            this.message = 'Prawdopodobnie złe dane logowania';
                            this.snackbar = true;
                            this.$emit('spinner', false);
                        }

                    }).catch(err => {
                        console.error(err);
                    });

        }
    }
}
</script>
<style scoped lang-="scss">
.container {
    /* max-width: 100vw;
    max-height: 100vh;
    overflow: hidden;
    position: absolute */
}


button {
    margin-right: 20px;

    &.theme--light.v-btn.v-btn--icon {
        color: rgba(0, 0, 0, .8);
    }
}



.image-wrapper {
    padding: 0px !important;


}

.v-application .text-h2 {
    font-size: 22px !important;
}

.image-column {
    padding: 0px !important;
    overflow: hidden;
    left: 10vw;
    position: relative;
}

.v-dialog {
    padding: 0px !important;
}

.v-card__text {
    padding: 0px !important;
    margin: 0px;
}

.v-card__text>* {
    padding: 0px !important;
    margin: 0px;
}

.v-image__image--cover {
    background-size: contain !important;
}

.login-component {
    max-height: 90vh;
    overflow: hidden;

    .margin {
        margin-right: 20px !important;
    }

    .v-card {
        overflow: hidden !important;
        border: 0px !important;
        height: 100vh;
    }


    .v-card__text {
        padding: 0px !important;

        .text-h2.pa-12 {
            padding-right: 0px !important;
        }
    }

}
</style>